package com.usky.fire.service;

import com.usky.common.mybatis.core.CrudService;
import com.usky.fire.domain.PatrolInspectionPlanSon;
import com.usky.fire.service.vo.DataCountVo;
import com.usky.fire.service.vo.PatrolInspectionContentVo;
import com.usky.fire.service.vo.PatrolInspectionPlanSonVo;
import com.usky.fire.service.vo.PlanRecordVo;

import java.util.List;
import java.util.Map;

/**
 * <p>
 * 服务类
 * </p>
 *
 * @author JCB
 * @since 2022-07-18
 */
public interface PatrolInspectionPlanSonService extends CrudService<PatrolInspectionPlanSon> {

    /**
     * 手机端-巡检自检-首页
     *
     * @param personnelId 人员ID
     * @return
     */
    Map<String, Object> appPlanStatistics(Integer personnelId, String currentDate);

    /**
     * 手机端-巡检自检-巡检计划
     *
     * @param personnelId
     * @param currentDate
     * @param sort
     * @return
     */
    Map<String, Object> patrolInspectionPlan(Integer personnelId, String currentDate, String sort);


    /**
     * 手机端-巡检自检-巡检计划-扫码查询计划
     *
     * @param siteNubmber 地点号码
     * @param personnelId 人员ID
     * @return
     */
    List<PatrolInspectionPlanSonVo> planList(String siteNubmber, Integer personnelId);


    /**
     * 手机端-巡检自检-巡检扫码地点详情
     *
     * @param siteId      地点ID
     * @param siteNubmber 地点号码
     * @return
     */
    Map<String, Object> siteDetails(Integer siteId, String siteNubmber);


    /**
     * 手机端-巡检自检-巡检上报-提交
     * @param planRecordVo
     */
    void updatePlan(PlanRecordVo planRecordVo);


    /**
     * 手机端-巡检自检-子计划巡检点位统计
     *
     * @param planSonId        子计划ID
     * @param inspectionStatus 巡检状态（1 未巡检，2 已巡检）
     * @return
     */
    Integer planSiteSonCount(Integer planSonId, Integer inspectionStatus);

    /**
     * 手机端-巡检自检-根据巡检地点ID查巡检内容
     *
     * @param siteId 地点ID
     * @return
     */
    List<PatrolInspectionContentVo> contentList(Integer siteId);

    /**
     * 手机端-巡检自检-巡检计划列表查询
     *
     * @param planIdList
     * @param currentDate
     * @param sort
     * @return
     */
    List<PatrolInspectionPlanSonVo> patrolInspectionPlanSon(List<Integer> planIdList, String currentDate, String sort);


    /**
     * 手机端-巡检自检-巡检任务-巡检子计划地点统计
     *
     * @param planSonidList    子计划ID
     * @param inspectionStatus 巡检状态（1 未巡检，2 已巡检）
     * @return
     */
    List<DataCountVo> planSiteSonCount(List<Integer> planSonidList, Integer inspectionStatus);

    /**
     * 手机端-巡检子计划数量查询
     *
     * @param planIdList  主计划ID
     * @param completion  完成百分比
     * @param currentDate 当前日期
     * @return
     */
    Integer planSonCount(List<Integer> planIdList, Integer completion, String currentDate);
}
